local table             = require "hp/lang/table"
local class             = require "hp/lang/class"
local Event             = require "hp/event/Event"
local Component         = require "hp/gui/Component"
local ProgressIndicator = require "modules/progress_indicator"

-- class define
local M                 = class(Component)
local super             = Component
function M:initInternal()
  super.initInternal(self)
end

function M:createChildren()
  
  local backgroundTexture = MOAITexture.new ()
  backgroundTexture:load ( "../assets/bg_texture.png" )
  backgroundTexture:setWrap ( true )
  backgroundTexture:setFilter(MOAITexture.GL_LINEAR,MOAITexture.GL_LINEAR)
    
  self._bgSprite = Sprite {
    parent = self,
  }
  self._bgSprite:setTexture(backgroundTexture)
  
  -- self._progressView:setColor(0,0,0,0)
  
  self._loadContent = Sprite {
    parent = self,
    texture = "../assets/photo_icon_sharing.png"
  }

  self._progressView = ProgressIndicator {
    parent = self,
    size = { 214, 34},
  }

end

function M:resizeHandler(e)
  self._bgSprite.deck:setUVRect(0, 0,self:getWidth() /100 , -self:getHeight()/100)  
  self._bgSprite:setSize(self:getWidth(), self:getHeight())
  self._loadContent:setPos((self:getWidth() - self._loadContent:getWidth())/2,(self:getHeight() - self._loadContent:getHeight())/2 - 30)
  self._progressView:setPos((self:getWidth() - self._progressView:getWidth())/2, self._loadContent:getBottom() + 60)
end

function M:startAnimation()
  self._progressView:startAnimation()
end

function M:stopAnimation()
  self._progressView:stopAnimation()
end

return M
