
DeviceOrientation = {}
require "global_variables"
require "utilities"

function DeviceOrientation.new ()
	local self = {}
	local callback
	print("currentOrientation " .. toString(currentOrientation))
	TOLERANCE = 10
	-- ported from OrientationEventListener.java
	local function getOrientation(X,Y,Z)
		X = -X
		Y = -Y
		Z = -Z	
		local magnitude = X*X + Y*Y;
		local orientation = -1

		--print("X=" .. X .. " Y=" .. Y .. " Z=" .. Z)

		if (X == 5) then orientation = 0 end
		if (X == 4) then orientation = 270 end
		if (X == 3) then orientation = 180 end
		if (X == 2) then orientation = 90 end

		--print("Orientation=" .. orientation .. " X=" .. X)

		if ((orientation ~= -1) and (orientation ~= mOrientation)) then
		      --print("Changing orientation, OLD=" .. mOrientation .. " NEW=" + orientation );
		      mOrientation = orientation;
		end

		if (magnitude * 4 >= Z*Z) then
		    local OneEightyOverPi = 57.29577957855;
		    local angle = math.atan2 (-Y, X) * OneEightyOverPi;
		    orientation = 90 - math.floor(angle);

		    -- normalize to 0 - 359 range
		    while (orientation >= 360) do
		        orientation = orientation - 360
		    end
		    while (orientation < 0) do
		        orientation = orientation + 360
		    end
		end

		if (orientation ~= mOrientation) then
			mOrientation = orientation
			--print("Changing orientation, OLD=" .. mOrientation .. " NEW=" .. orientation );		
		end

		return mOrientation
	end

	local function onLevelEvent ( X, Y, Z ) 
		local orientation = getOrientation(X,Y,Z)
		local nextOrientation = nil
		if(orientation == -1) then
			--print("orientation: flat")
			return
		end

		if(orientation > 360 - TOLERANCE or orientation < TOLERANCE) then
			nextOrientation = Orientation.PORTRAIT_DOWN
		elseif (orientation > 90 - TOLERANCE and orientation < 90 + TOLERANCE ) then
			nextOrientation = Orientation.LANDSCAPE_LEFT
		elseif (orientation > 180 - TOLERANCE and orientation < 180 + TOLERANCE ) then
			nextOrientation = Orientation.PORTRAIT_UP
		elseif (orientation > 270 - TOLERANCE and orientation < 270 + TOLERANCE ) then
			nextOrientation = Orientation.LANDSCAPE_RIGHT
		end

		if ( nextOrientation ~= currentOrientation  and nextOrientation ~= nil) then
      print("old orientation: " .. toString(currentOrientation) .. ", new orientation: " .. toString(nextOrientation) .. " angle=" .. orientation)
			currentOrientation = nextOrientation
			if(callback ~= nil) then
				callback(currentOrientation, orientation)
      else
        print("orientation call back is nil")  
			end
		end
	end
	
	function self.setCallback(self,  func )
		print ("callback set")
		callback = func
	end

	if MOAIInputMgr.device.level then
		MOAIInputMgr.device.level:setCallback ( onLevelEvent )
	else
		print( "Level object not found!!")
	end
	
	return self
end