InputPointerHelper = {}

local clickCallback
local pointerCallback
local mouseX
local mouseY

local function pointerCallbackPrivate ( x, y )
  --require('mobdebug').on()
  mouseX = x
  mouseY = y
  
  if pointerCallback then
    pointerCallback(x, y)
  end
 
end
		
local function clickCallbackPrivate ( down )
  --require('mobdebug').on()
  if clickCallback then
    clickCallback(down, mouseX, mouseY)
  end
    
end

InputPointerHelper.registerCallbacks = function( _clickCallback, _pointerCallback )
  clickCallback = _clickCallback
  pointerCallback = _pointerCallback 
  if MOAIInputMgr.device.pointer then
    
    -- mouse input
    MOAIInputMgr.device.pointer:setCallback ( pointerCallbackPrivate )
    MOAIInputMgr.device.mouseLeft:setCallback ( clickCallbackPrivate )
  else

    -- touch input
    MOAIInputMgr.device.touch:setCallback ( 
      function ( eventType, idx, x, y, tapCount )

        if pointerCallback then
          pointerCallback ( x, y )
        end
      
        if eventType == MOAITouchSensor.TOUCH_DOWN then
          clickCallbackPrivate ( true )
        elseif eventType == MOAITouchSensor.TOUCH_UP then
          clickCallbackPrivate ( false )
        end
      end
    )
  end
end
