----------------------------------------------------------------
-- Copyright (c) 2010-2011 Zipline Games, Inc. 
-- All Rights Reserved. 
-- http://getmoai.com
----------------------------------------------------------------

package.path = "?.lua"
require "input-pointer-helper"

MOAISim.openWindow ( "test1", 320, 480 )

viewport = MOAIViewport.new ()
viewport:setSize ( 320, 480 )
viewport:setScale ( 320, -480 )

layer = MOAILayer2D.new ()
layer:setViewport ( viewport )
MOAISim.pushRenderPass ( layer )

gfxQuad = MOAIGfxQuad2D.new ()
gfxQuad:setTexture ( "moai.png" )
gfxQuad:setRect ( -128, -128, 128, 128 )
gfxQuad:setUVRect ( 0, 0, 1, 1 )

prop = MOAIProp2D.new ()
prop:setDeck ( gfxQuad )
layer:insertProp ( prop )

prop:moveRot ( 360, 1.5 )
print ('Time: ' ..  os.time())
math.randomseed( os.time() )


function onClick(down, x, y)
  if down then
    st = MOAIP2PChannel.getState()
    print('Get state: ' .. st)    
    
    if st==1 then
      local msg = 'clicked: ' .. math.random(1, 5000)
      print('Sending: ' .. msg)
      MOAIP2PChannel.send( msg )
    end   
  end  
end

function connectionMonitorFunc()
  local prevState = -99
  while true do
    coroutine:yield ()
    local currState = MOAIP2PChannel.getState()
    if prevState ~= currState then
      print ('State changed. Old state=' .. prevState .. ' new state=' .. currState)
      prevState = currState
    end

    local data = nil
    if currState == MOAIP2PChannel.CONNECTED then
      data = MOAIP2PChannel.receive()
    end

    if data ~= nil then
      print ('Received data: ' .. data)
      prop:moveRot ( 360, 1.5 )
      
    end
  end
end

connectionMonitorThread = MOAICoroutine.new ()
connectionMonitorThread:run ( connectionMonitorFunc )


MOAIP2PChannel.setOnStateChangedCallback(
  function(newState)  
    print ('State notification received: ' .. newState)  
  end
)
MOAIP2PChannel.setOnReceiveCallback(
  function()
    print ('Got receive notification')
  end
)

InputPointerHelper.registerCallbacks(onClick, nil)

print(MOAIP2PChannel.INVALID)
print(MOAIP2PChannel.DISCONNECTED)
print(MOAIP2PChannel.CONNECTED)
